from singletons.database_singleton import DatabaseSingleton

class ReservationRepository:
    db = DatabaseSingleton.get_instance()

    @classmethod
    def insert(cls, reservation):
        cls.db.reservation.insert_one(reservation.__dict__)

    @classmethod
    def delete(cls, reservation_id):
        try:
            result = cls.db.reservation.delete_one({"_id": ObjectId(reservation_id)})
            return result
        except:
            return None

    @classmethod
    def update(cls, reservation_id, data):
        try:
            result = cls.db.reservation.update_one({"_id": ObjectId(reservation_id)}, {"$set": data})
            return result
        except:
            return None

    @classmethod
    def get_by_id(cls):
        return list(cls.db.reservation.find({"_id": ObjectId(reservation_id)}))

    @classmethod
    def list_all(cls, filters=None):
        query = {}
        if filters:
            if "start_date" in filters:
                query["start_date"] = {"$gte": filters["start_date"]}
            if "end_date" in filters:
                query["start_date"] = {"$lte": filters["end_date"]}
            if "room_id" in filters:
                query["room_id"] = filters["room_id"]
        return list(cls.db.reservation.find(query))